#include <gdnative_api_struct.gen.h>
#include <net/godot_net.h>
#include <stdio.h>

/* Singleton */
static bool _singleton = false;

extern "C" void GDN_EXPORT godot_gdnative_singleton() {
	printf("SINGLETON!");
	_singleton = true;
	fflush(stdout);
}

/* Godot export stuff */
extern "C" void GDN_EXPORT godot_gdnative_init(godot_gdnative_init_options *o) {
	printf("INIT!");
	fflush(stdout);
}

extern "C" void GDN_EXPORT godot_gdnative_terminate(godot_gdnative_terminate_options *o) {
	printf("TERMINATE!");
	if (_singleton) {
		_singleton = false;
		printf("REMOVE!");
	}
	fflush(stdout);
}

extern "C" void GDN_EXPORT godot_nativescript_init(void *handle) {
	printf("Script init!");
	fflush(stdout);
}
